unit data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TDataForm = class(TForm)
    CreateButton: TButton;
    DisplayButton: TButton;
    DisplayList: TListBox;
    ExitButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CreateButtonClick(Sender: TObject);
    procedure DisplayButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataForm: TDataForm;

implementation

{$R *.DFM}

type
person = record
    first : string[10];
    last : string[20];
    age : integer;
    end;
    
var datafile : file of person;
    persondata : person;

procedure TDataForm.FormCreate(Sender: TObject);
//Locate file to store data
begin
     AssignFile(datafile, 'names.dat');
end;

procedure TDataForm.CreateButtonClick(Sender: TObject);
//Write three sets of data to disc
var count : integer;
begin
rewrite(datafile);
for count := 1 to 3 do
    begin
    persondata.first := Inputbox('Name','Enter christian name','');
    persondata.last:= Inputbox('Name','Enter surname','');
    persondata.age:= StrToInt(Inputbox('Name','Enter age',''));
    write(datafile, persondata);
    end;
end;

procedure TDataForm.DisplayButtonClick(Sender: TObject);
//Read data from disc
begin
reset(datafile);
while not eof(datafile) do
    begin
    read(datafile, persondata);
    DisplayList.Items.Add(persondata.first);
    DisplayList.Items.Add(persondata.last);
    DisplayList.Items.Add(IntToStr(persondata.age));
    end;
end;

procedure TDataForm.ExitButtonClick(Sender: TObject);
//Close file and exit
begin
     CloseFile(datafile);
     Application.Terminate;
end;

end.
