unit data;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TDataForm = class(TForm)
    StartButton: TBitBtn;
    ScoreButton: TBitBtn;
    Label1: TLabel;
    CalcButton: TBitBtn;
    DisplayButton: TBitBtn;
    ExitButton: TBitBtn;
    DisplayList: TListBox;
    procedure StartButtonClick(Sender: TObject);
    procedure ScoreButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure CalcButtonClick(Sender: TObject);
    procedure DisplayButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataForm: TDataForm;

implementation

{$R *.DFM}

type
    name = record                   //Student data
         first_name : string[12];
         surname : string[20];
         id_numb : integer;
         average : real;
         end;
    results = record                //Student results
         maths : integer;
         english : integer;
         science : integer;
         end;

var student : array[1..4] of name;
    score : array[1..4] of results;

procedure TDataForm.StartButtonClick(Sender: TObject);
//Collect student data
var count : integer;
    numb : string;
begin
     StartButton.Visible := false;
     for count := 1 to 4 do
         with student[count] do
              begin
              numb := IntToStr(count);
              first_name := InputBox('Student ' + numb, 'Enter christian name','');
              surname := InputBox('Student ' + numb, 'Enter surname','');
              id_numb := StrToInt(InputBox('Student ' + numb, 'Enter ID number',''));
              end;
     ScoreButton.Visible := true;
end;

procedure TDataForm.ScoreButtonClick(Sender: TObject);
//Collect subject results
var  count : integer;
     name : string;
begin
     ScoreButton.Visible := false;
     for count := 1 to 4 do
         begin
         name := student[count].first_name + ' ' + student[count].surname;
         with score[count] do
              begin
              maths := StrToInt(InputBox('Scores',
                                'Enter Maths score for ' + name, ''));
              english := StrToInt(InputBox('Scores',
                                'Enter English score for '+ name, ''));
              science := StrToInt(InputBox('Scores',
                                'Enter Science score for '+ name, ''));
              end;
         end;
     CalcButton.Visible := true;
end;

procedure TDataForm.ExitButtonClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TDataForm.CalcButtonClick(Sender: TObject);
//Caculate average scores
var  count : integer;
begin
     CalcButton.Visible := false;
     for count := 1 to 4 do
          with score[count] do
              student[count].average := (maths + english + science) / 3;
     DisplayButton.Visible := true;
end;

procedure TDataForm.DisplayButtonClick(Sender: TObject);
//Display average score
var  count : integer;
     result: string;
begin
     DisplayList.Visible := true;
     for count := 1 to 4 do
        begin
        result := FloatToStrF(student[count].average,ffFixed,5,2);
        DisplayList.Items.Add(student[count].surname + ' ' + result) ;
        end;
     DisplayButton.Visible := false;
end;

end.
