unit die;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TDieForm = class(TForm)
    DieImage: TImage;
    Timer1: TTimer;
    ResetButton: TButton;
    PauseButton: TButton;
    ExitButton: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    OneCountButton: TButton;
    TwoCountButton: TButton;
    ThreeCountButton: TButton;
    FourCountButton: TButton;
    FiveCountButton: TButton;
    SixCountButton: TButton;
    procedure ResetButtonClick(Sender: TObject);
    procedure PauseButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DieForm: TDieForm;

implementation

{$R *.DFM}

var numb : array[1..6] of integer;

procedure TDieForm.ResetButtonClick(Sender: TObject);
//Reset array to 0 and clear label captions
var j : integer;
begin
     randomize;
     for j := 1 to 6 do
         numb[j] := 0;
     OneCountButton.Caption := '';
     TwoCountButton.Caption := '';
     ThreeCountButton.Caption := '';
     FourCountButton.Caption := '';
     FiveCountButton.Caption := '';
     SixCountButton.Caption := '';
end;

procedure TDieForm.PauseButtonClick(Sender: TObject);
//Toggle timer
begin
     Timer1.Enabled := not Timer1.Enabled;
     if Timer1.Enabled then
        PauseButton.Caption := '&Pause'
     else
        PauseButton.Caption := '&Continue';
end;

procedure TDieForm.ExitButtonClick(Sender: TObject);
begin
     close;
end;

procedure TDieForm.Timer1Timer(Sender: TObject);
//Simulate roll of die and display count
var   die : integer;
begin
     die := random(6) + 1;
     DieImage.Picture.LoadFromFile(IntToStr(die) + '.bmp');
       	{Add bitmap extension to die value and display as DieImage}
     numb[die] := numb[die] + 1;
     case die of
          1: OneCountButton.Caption := IntToStr(numb[die]);
          2: TwoCountButton.Caption := IntToStr(numb[die]);
          3: ThreeCountButton.Caption := IntToStr(numb[die]);
          4: FourCountButton.Caption := IntToStr(numb[die]);
          5: FiveCountButton.Caption := IntToStr(numb[die]);
          6: SixCountButton.Caption := IntToStr(numb[die]);
          end;
end;

end.
