unit lotto;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DateUtils;

type
  TLottoForm = class(TForm)
    DrawEdit: TEdit;
    SuppEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    StartButton: TButton;
    SuppButton: TButton;
    ExitButton: TButton;
    TitleLabel: TLabel;
    Label4: TLabel;
    NumberLabel: TLabel;
    ClearButton: TButton;
    procedure ExitButtonClick(Sender: TObject);
    procedure StartButtonClick(Sender: TObject);
    procedure SuppButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LottoForm: TLottoForm;

implementation

{$R *.DFM}

var numbers : set of 1..45;
    numb : integer = 100;

procedure pause (wait : integer);
//Pauses number of seconds in wait parameter
var stop : TDateTime;
begin
        stop := IncSecond(time, wait);
        repeat
             until time > stop;
end;

procedure TLottoForm.ExitButtonClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TLottoForm.StartButtonClick(Sender: TObject);
//Choose six random numbers between 1 and 45
var  draw, ball : integer;
begin
     randomize;
     numbers := [];                     //empty set
     StartButton.Visible := false;
     numb := numb + 1;                  //number of draw
     NumberLabel.Caption := IntToStr(numb);
     pause(1);
     for draw := 1 to 6 do
         begin
         repeat                         //select number
               ball := random(45) + 1;
               until not(ball in numbers);
         numbers := numbers + [ball];
         DrawEdit.Text := DrawEdit.Text +  IntToStr(ball) + '  ';
         refresh;
         beep;
         pause(1);
         end;
     SuppButton.Visible := true;
end;

procedure TLottoForm.SuppButtonClick(Sender: TObject);
//Choose two random numbers between 1 and 45
var  draw, ball : integer;
begin
     SuppButton.Visible := false;
     pause(2);
     for draw := 7 to 8 do
         begin
         repeat
               ball := random(45) + 1;
               until not(ball in numbers);
         numbers := numbers + [ball];
         SuppEdit.Text := SuppEdit.Text +  IntToStr(ball) + '  ';
         refresh;
         beep;
         pause(2);
         end;
     ClearButton.Visible := true;       //Restart if wish
end;

procedure TLottoForm.ClearButtonClick(Sender: TObject);
//Clear display and restart simulation
begin
     ClearButton.Visible := false;
     DrawEdit.Text := '' ;       
     SuppEdit.Text := '' ;
     StartButton.Visible := true;
end;

end.
